###########################################
# DeleteBuildRasterAttributeTable.py 
# Draft version Date: Nov 16th, 2011
# Script Written By:  Kirk Sherrill NPS-NRPC-I&M GIS Program
# 
# Abstract:  Per Raster in the defined inputWorkspace the raster attribute table will be deleted
# and then subsequently rebuilt. 
##########################################

###################################################
# Start of Parameters requiring set up.
###################################################

## Required Data Layers
workspace = "Y:\\Projects_2012\\Sounds2012\\workspace\\"            ##root workspace
inputWorkspace = "Y:\\Projects_2012\\Sounds2012\\Data\\test\\NLCD1mile.gdb"  ##Input workspace with Rasters to be processed                                    

logFileName = workspace + "Raster_Attribute_Table_NLCD1mile.txt"           ##LogFile Name/Path


###################################################
# End of Parameters requiring set up.
###################################################

# Import system modules
import sys, string, os, arcgisscripting, math, arcpy, glob
from arcpy import env
from arcpy.sa import *

# Check out any necessary licenses
arcpy.CheckOutExtension("Spatial")
# Set overwrite files to True 
arcpy.geoprocessing.env.overwriteOutput = True
# Set geoprocessing work space
arcpy.geoprocessing.env.workspace = workspace



def timeFun():          #Function to Grab Time
    from datetime import datetime
    b=datetime.now()
    messageTime = b.isoformat()
    return messageTime

#################################################
##Beginning routine to run indivual Fuzzy Viewsheds per development point
#################################################
try:
               
    env.workspace = inputWorkspace
    dataFiles = arcpy.ListRasters("*", "GRID") #Grab the list of folders containing the files needing to be extracted
           
    for file in dataFiles:          #Data Source Files to be clipped/extracted
        
        if os.path.exists(logFileName):
            pass
        else:
            logFile = open(logFileName, "w")
            logFile.close()

        lf_read = ""
        logFile = open(logFileName, "r")
        lf_read = logFile.read()
        logFile.close()        
        testLine = "Successfully Processed - " + file    #Checking logfile for this syntax - if there then already processed
        if testLine in lf_read:
            
            messageTime = timeFun()
            logFile = open(logFileName, "a")
            scriptMsg = "Skipping - " + park + " - for file " + name + "_has been previously processed" + messageTime
            logFile.write(scriptMsg + "\n")
            logFile.close()
            continue
        else:
      
            arcpy.DeleteRasterAttributeTable_management(file) 
            arcpy.BuildRasterAttributeTable_management(file, "Overwrite")

            #Write log message
            logFile = open(logFileName, "a")
            messageTime = timeFun()            
            scriptMsg = "Successfully Processed - " + file + " " + messageTime 
            logFile.write(scriptMsg + "\n")
            logFile.close()    
            
                   
except:
    messageTime = timeFun()
    scriptMsg = "Exiting DeleteBuildRasterAttributeTable.py Error" 
    print "Exiting DeleteBuildRasterAttributeTable.py Exited\nSee log file " + logFileName + " for more details - " + messageTime
    logFile = open(logFileName, "a")
    logFile.write(scriptMsg + "\n")
    logFile.close()
    
finally:
    messageTime = timeFun()
    scriptMsg = "Finished DeleteBuildRasterAttributeTable.py" + " << " + messageTime
    logFile = open(logFileName, "a")
    logFile.write(scriptMsg + "\n")
    logFile.close()
    