###########################################
# intersectWind.py 
# Draft version Date: May 17, 2011
# Script Written By:  Kirk Sherrill NPS-NRPC-I&M GIS Program
# 
# Abstract:  
#  Intersects points with a polygon file
#
##########################################

###################################################
# Start of Parameters requiring set up.
###################################################

## Required Data Layers
workspace = "Y:\\Projects_2012\\Sounds2012\\Data\\wind\\Scratch\\"            #Scratch workspace
outWorkspace = "Y:\\Projects_2012\\Sounds2012\\Data\\WindData.gdb\\"        ##output Workspace
suffix = "WindData"         

processList = "Y:\\Projects_2012\\Sounds2012\\Data\\wind\\SourceData\\NREL\\WindDataProcessing.csv"           #List of Parks to Process

logFileName = workspace + "intersectList.txt"
###################################################
# End of Parameters requiring set up.
###################################################

# Import system modules
import sys, string, os, arcgisscripting, math, arcpy, glob
from arcpy import env
from arcpy.sa import *

# Check out any necessary licenses
arcpy.CheckOutExtension("Spatial")
# Set overwrite files to True 
arcpy.geoprocessing.env.overwriteOutput = True
# Set geoprocessing work space
arcpy.geoprocessing.env.workspace = workspace

if os.path.exists(logFileName):
    pass
else:
    logFile = open(logFileName, "w")
    logFile.close()


def timeFun():          #Function to Grab Time
    from datetime import datetime
    b=datetime.now()
    messageTime = b.isoformat()
    return messageTime

#################################################
##Beginning routine to run indivual Fuzzy Viewsheds per development point
#################################################
try:
        
    readFile = open(processList, "r")

    lineCount = 1
    for line in readFile:               #Loop Per Park
        if lineCount == 1:
            lineCount = lineCount + 1
            pass
        else:
            split = line.split(",")
            
            state = str(split[0])
            pointFile = str(split[1])
            dataFile = str(split[2])
            outFile2 =  outWorkspace + state + "_" + suffix          #Output File

            if dataFile == "N/A":
                pass
            else:

                lf_read = ""
                logFile = open(logFileName, "r")
                lf_read = logFile.read()
                logFile.close()

                testLine = "Completed " + str(outFile2)

                if testLine in lf_read:
                    
                    messageTime = timeFun()
                    logFile = open(logFileName, "a")
                    scriptMsg = "Skipping Point - " + str(outFile2) + " - has been previously processed" + messageTime
                    logFile.write(scriptMsg + "\n")
                    logFile.close()
                    continue

                else: 

                    inFeatures = ([[pointFile, 1], [dataFile, 2]])
                    arcpy.Intersect_analysis(inFeatures, outFile2, "", "", "point")

                    messageTime = timeFun()
                    logFile = open(logFileName, "a")
                    
                    scriptMsg = "Completed " + str(outFile2) + " - " + messageTime
                    logFile.write(scriptMsg + "\n")
                    logFile.close()


                    lineCount = lineCount + 1
            
except:
    messageTime = timeFun()
    scriptMsg = "IntersectWind.py Error" 
    print "IntersectWind.py Exited\nSee log file " + logFileName + " for more details - " + messageTime
    
    
finally:
    messageTime = timeFun()
    logFile = open(logFileName, "a")
    scriptMsg = "IntersectWind.py Completed" + " << " + messageTime
    logFile.write(scriptMsg + "\n")
    logFile.close()
    