###########################################
# Projection_Loop.py -
# 
##########################################

###################################################
# Start of Parameters requiring set up.
###################################################

## Required Data Layers
workspace = "E:\\SolarPEIS\\workspace\\"            #Scratch workspace
inputWorkspace = "E:\\SolarPEIS\\workspace\\albers\\"  #Output geodatabase or workspace                                    ## Setting output workspace variable
demWorkspace = "E:\\SolarPEIS\\workspace\\" #Location with DEM's
projFile = "E:\\SolarPEIS\\ELCA_AOI.gdb\\ELCA_25mile_albers"   #File with the projection to be used in reprojection 

logFileName = workspace + "AA_Reproject_DEM10m.txt"


###################################################

# End of Parameters requiring set up.
###################################################

# Import system modules
import sys, string, os, arcgisscripting, math, arcpy, glob
from arcpy import env
from arcpy.sa import *

# Check out any necessary licenses
arcpy.CheckOutExtension("Spatial")
# Set overwrite files to True 
arcpy.geoprocessing.env.overwriteOutput = True
# Set geoprocessing work space
arcpy.geoprocessing.env.workspace = workspace



def timeFun():          #Function to Grab Time
    from datetime import datetime
    b=datetime.now()
    messageTime = b.isoformat()
    return messageTime

#################################################
##Beginning routine to run indivual Fuzzy Viewsheds per development point
#################################################
try:
        
          
        #Create GDB per Park
        describeAOI = arcpy.Describe(projFile)
        coordinateSystem = describeAOI.spatialReference
        env.workspace = demWorkspace

        # Get a list of ESRI GRIDs from the workspace and print
        rasterList = arcpy.ListRasters("*", "")

        for ras in rasterList:
                
            rasSplit = ras.split(".")
            
            outRaster = inputWorkspace + str(rasSplit[0])

            lf_read = ""
            logFile = open(logFileName, "r")
            lf_read = logFile.read()
            logFile.close()
            
            testLine = "Successfully Created - " + outRaster   #Checking logfile for this syntax - if there then already processed
            if testLine in lf_read:
                
                messageTime = timeFun()
                logFile = open(logFileName, "a")
                scriptMsg = "Skipping - " + outRaster + " Has been previously processed" + messageTime
                logFile.write(scriptMsg + "\n")
                logFile.close()
                pass                

            else:

                arcpy.ProjectRaster_management(ras, outRaster, coordinateSystem, "CUBIC", "10")

                messageTime = timeFun()
                logFile = open(logFileName, "a")
                scriptMsg = "Successfully Projected - " + outRaster + "-" + messageTime
                logFile.write(scriptMsg + "\n")
                logFile.close()

            
except:
    messageTime = timeFun()
    scriptMsg = "Projection_Loop.py Error" 
    print "Projection_Loop.py Exited\nSee log file " + logFileName + " for more details - " + messageTime
    logFile = open(logFileName, "a")
    logFile.write(scriptMsg + "\n")
    logFile.close()
    
finally:
    messageTime = timeFun()
    scriptMsg = "Projection_Loop.py " + " << " + messageTime
    logFile = open(logFileName, "a")
    logFile.write(scriptMsg + "\n")
    logFile.close()
    